/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingPuntoVentaDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.PricingPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 
 * @author Rafius
 */
@Service("pricingPuntoVentaService")
public class PricingPuntoVentaServiceImpl implements PricingPuntoVentaService {

	@Autowired
	private PricingPuntoVentaDAO pricingPuntoVentaDAO;

	public List<PricingPuntoVenta> obtenerTodos() {
		return pricingPuntoVentaDAO.obtenerTodos();
	}

	public PricingPuntoVenta obtenerID(Integer id) {
		return pricingPuntoVentaDAO.obtenerID(id);
	}

	@Transactional
	public PricingPuntoVenta suscribir(PricingPuntoVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingPuntoVentaDAO.suscribir(entidad);
	}

	@Transactional
	public PricingPuntoVenta actualizacion(PricingPuntoVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingPuntoVentaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(PricingPuntoVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.EXCLUIDO);

		pricingPuntoVentaDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingPuntoVenta(Pricing pricing, PuntoVenta puntoVenta) {
		return pricingPuntoVentaDAO.obtenerPricingPuntoVenta(pricing, puntoVenta);
	}

	@Override
	@Transactional
	public void borrar(List<PricingPuntoVenta> pricingPuntoVentas) {
		if(pricingPuntoVentas != null && !pricingPuntoVentas.isEmpty()) {
			for (PricingPuntoVenta pricingPuntoVenta : pricingPuntoVentas) {
				borrar(pricingPuntoVenta);
			}
		}
	}
}
